package dev.fyloz.colorrecipesexplorer.service.files

import dev.fyloz.colorrecipesexplorer.utils.FilePath

object FileExistCache {
    private val map = hashMapOf<FilePath, Boolean>()

    /** Checks if the given [path] is in the cache. */
    operator fun contains(path: FilePath) =
        path in map

    /** Checks if the file at the given [path] exists. */
    fun exists(path: FilePath) =
        map[path] ?: false

    /** Sets the file at the given [path] as existing. */
    fun setExists(path: FilePath) =
        set(path, true)

    /** Sets the file at the given [path] as not existing. */
    fun setDoesNotExists(path: FilePath) =
        set(path, false)

    private fun set(path: FilePath, exists: Boolean) {
        map[path] = exists
    }
}